const node_openssl = require('../index.js');
var fs = require('fs');
var tmp = require('tmp');

var options = {
	binpath: 'C:/Program Files/OpenSSL-Win64/bin/openssl.exe'
}

var openssl = new node_openssl(options);

var rsakeyoptions = {
	rsa_keygen_bits: 2048,
	//rsa_keygen_pubexp: 65537,
	format: 'PKCS8'
}

var csroptions = {
	hash: 'sha256',
	string_mask: 'nombstr',
	requestAttributes: {
		challengePassword: 'FXUTWAXI22NSGEFG',
		//unstructuredName: 'Optional Company Name'
	},
	subject: {
		countryName: 'US',
		stateOrProvinceName: 'Louisiana',
		localityName: 'Slidell',
		commonName: [
			'certificatetools.com',
			'www.certificatetools.com'
		],
	},
	extensions: {
		SANs: {
			DNS: [
				'google.com',
				'www.google.com'
			]
		}
	}
}

openssl.generateRSAPrivateKey(rsakeyoptions, function(err, key, cmd) {
	if(err) {
		console.log(err);
	} else {
		openssl.generateCSR(csroptions, key, false, function(err, csr, cmd) {
			if(err) {
				console.log(err);
			} else {
				console.log(csr);
				console.log(cmd.files.config);
				/*openssl.selfSignCSR(csr, csroptions, key, false, function(err, crt, cmd) {
					if(err) {
						console.log(err);
						console.log(cmd.files.config);
					} else {
						console.log(crt);
						console.log(cmd.files.config);
					}
				});*/
			}
		});
	}
});